// tslint:disable
/**
 * OpenAPI Petstore
 * This is a sample server Petstore server. For this sample, you can use the api key `special-key` to test the authorization filters.
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import { Observable } from 'rxjs';
import { BaseAPI } from '../runtime';
import {
    ,
    ,
} from '../models';

export interface AddPetRequest {
    body: Pet;
}

export interface DeletePetRequest {
    petId: number;
    apiKey?: string;
}

export interface FindPetsByStatusRequest {
    status: Array<StatusEnum>;
}

export interface FindPetsByTagsRequest {
    tags: Array<string>;
}

export interface GetPetByIdRequest {
    petId: number;
}

export interface UpdatePetRequest {
    body: Pet;
}

export interface UpdatePetWithFormRequest {
    petId: number;
    name?: string;
    status?: string;
}

export interface UploadFileRequest {
    petId: number;
    additionalMetadata?: string;
    file?: Blob;
}

/**
 * no description
 */
export class PetApi extends BaseAPI {

    /**
     * Add a new pet to the store
     */
    addPet = (requestParameters: AddPetRequest): Observable<void> => {
        throwIfRequired(requestParameters, 'body', 'addPet');

        return this.request<void>({
            path: '/pet',
            method: 'POST',
            body: requestParameters.body,
        });
    };

    /**
     * Deletes a pet
     */
    deletePet = (requestParameters: DeletePetRequest): Observable<void> => {
        throwIfRequired(requestParameters, 'petId', 'deletePet');

        return this.request<void>({
            path: '/pet/{petId}'.replace('{petId}', encodeURI(requestParameters.petId)),
            method: 'DELETE',
        });
    };

    /**
     * Multiple status values can be provided with comma separated strings
     * Finds Pets by status
     */
    findPetsByStatus = (requestParameters: FindPetsByStatusRequest): Observable<Array<Pet>> => {
        throwIfRequired(requestParameters, 'status', 'findPetsByStatus');

        const query: HttpQuery = {
            ...(requestParameters.status && { 'status': requestParameters.status.join(COLLECTION_FORMATS['csv']) }),
        };

        return this.request<Array<Pet>>({
            path: '/pet/findByStatus',
            method: 'GET',
            query,
        });
    };

    /**
     * Multiple tags can be provided with comma separated strings. Use tag1, tag2, tag3 for testing.
     * Finds Pets by tags
     */
    findPetsByTags = (requestParameters: FindPetsByTagsRequest): Observable<Array<Pet>> => {
        throwIfRequired(requestParameters, 'tags', 'findPetsByTags');

        const query: HttpQuery = {
            ...(requestParameters.tags && { 'tags': requestParameters.tags.join(COLLECTION_FORMATS['csv']) }),
        };

        return this.request<Array<Pet>>({
            path: '/pet/findByTags',
            method: 'GET',
            query,
        });
    };

    /**
     * Returns a single pet
     * Find pet by ID
     */
    getPetById = (requestParameters: GetPetByIdRequest): Observable<Pet> => {
        throwIfRequired(requestParameters, 'petId', 'getPetById');

        return this.request<Pet>({
            path: '/pet/{petId}'.replace('{petId}', encodeURI(requestParameters.petId)),
            method: 'GET',
        });
    };

    /**
     * Update an existing pet
     */
    updatePet = (requestParameters: UpdatePetRequest): Observable<void> => {
        throwIfRequired(requestParameters, 'body', 'updatePet');

        return this.request<void>({
            path: '/pet',
            method: 'PUT',
            body: requestParameters.body,
        });
    };

    /**
     * Updates a pet in the store with form data
     */
    updatePetWithForm = (requestParameters: UpdatePetWithFormRequest): Observable<void> => {
        throwIfRequired(requestParameters, 'petId', 'updatePetWithForm');

        const formData = new FormData();
        if (requestParameters.name !== undefined) {
            formData.append('name', requestParameters.name as any);
        }

        if (requestParameters.status !== undefined) {
            formData.append('status', requestParameters.status as any);
        }

        return this.request<void>({
            path: '/pet/{petId}'.replace('{petId}', encodeURI(requestParameters.petId)),
            method: 'POST',
            body: formData,
        });
    };

    /**
     * uploads an image
     */
    uploadFile = (requestParameters: UploadFileRequest): Observable<ApiResponse> => {
        throwIfRequired(requestParameters, 'petId', 'uploadFile');

        const formData = new FormData();
        if (requestParameters.additionalMetadata !== undefined) {
            formData.append('additionalMetadata', requestParameters.additionalMetadata as any);
        }

        if (requestParameters.file !== undefined) {
            formData.append('file', requestParameters.file as any);
        }

        return this.request<ApiResponse>({
            path: '/pet/{petId}/uploadImage'.replace('{petId}', encodeURI(requestParameters.petId)),
            method: 'POST',
            body: formData,
        });
    };

}
